local isConfiguring = false;

BINDING_HEADER_MALOWINCANTERSFLOW = "MaloWIncantersFlow";
SLASH_MALOWINCANTERSFLOW1 = "/mif";
SLASH_MALOWINCANTERSFLOW2 = "/malowincantersflow";
local function MaloWIncantersFlow_SlashHandler(msg, editbox)
	if msg == "" or msg == nil then
		MaloWIncantersFlow_PrintMenu();
	end
	if msg == "lock" then
		
	end
	if msg == "combat" then
		
	end
	if msg == "resetpos" then
		MaloWIncantersFlowFrame:SetPoint("TOPLEFT", nil, "TOPLEFT", 400, -400);
	end
	if msg == "show" then
		MaloWIncantersFlowFrame:Show();
		isConfiguring = true;
		print("MaloWIncantersFlow is now being shown for configuration, type '/mif hide' to hide it when you're done");
	end
	if msg == "hide" then
		MaloWIncantersFlowFrame:Hide();
		isConfiguring = false;
		print("MaloWIncantersFlow is now hidden, it will automatically show when you're in combat and have Incanter's Flow as a buff");
	end
	if string.match(msg, "scale") then
		local scale = string.sub(msg, 7);
		MaloWIncantersFlowFrame:SetScale(scale);
		MaloWIncantersFlowSVScale = scale;
	end
end 
SlashCmdList["MALOWINCANTERSFLOW"] = MaloWIncantersFlow_SlashHandler;

function MaloWIncantersFlow_PrintMenu()
	print("MaloWIncantersFlow: Arguments to /mif :");
	print("scale - Scales the frame. Default 1.0");
	--print("lock - Toggles the frame being locked from movement");
	--print("combat - Toggles if the frame will hide when you leave combat");
	print("show - Shows the frame so you can configure it. Type '/mif hide' when you're done");
	print("hide - Hides the frames");
	print("resetpos - Resets the position of the frame");
end


local previousStacks = 0;
local previousStacksTime = 0;
local increasing = true;

function MaloWIncantersFlow_OnEvent(self, event, arg1, ...)
	if event == "ADDON_LOADED" and arg1 == "MaloWIncantersFlow" then
		if MaloWIncantersFlowSVScale == nil then
			MaloWIncantersFlowSVScale = 1.0;
		else
			MaloWIncantersFlowFrame:SetScale(MaloWIncantersFlowSVScale);
		end
	elseif event == "UNIT_AURA" then
		MaloWIncantersFlow_Update();
	end
end 

function MaloWIncantersFlow_OnUpdate(self, elapsed)
	MaloWIncantersFlow_Update();
end

function MaloWIncantersFlow_Update()
	local stacks = getIncantersFlowStacks();
	if isConfiguring == true then
		stacks = 3;
	else
		if stacks == 0 or UnitAffectingCombat("player") == false then
			MaloWIncantersFlowFrame:Hide();
			return;
		end
	end
	
	MaloWIncantersFlowFrame:Show();
	
	if previousStacks < stacks then
		increasing = true;
	elseif previousStacks > stacks then
		increasing = false;
	end
	
	
	local timeToNext = string.sub(tostring(getTimeUntillNext(stacks, increasing)), 1, 3);
	MaloWIncantersFlowFrameStackText:SetText(stacks);
	MaloWIncantersFlowFrameNextText:SetText(timeToNext);
	
	updateOverlayTextures(stacks, increasing);
	
	if stacks ~= previousStacks then
		previousStacksTime = GetTime();
		previousStacks = stacks;
	end
end

function getTimeUntillNext(stacks, increasing)
	local timeSincePrevious = GetTime() - previousStacksTime;
	local timeToNext = 0;
	if stacks == 5 then
		return 2 - timeSincePrevious;
	end
	if increasing then
		timeToNext = 5 - stacks;
	else
		timeToNext = stacks + 4;
	end
	return timeToNext - timeSincePrevious;
end



function updateOverlayTextures(stacks, increasing)
	if stacks == 5 then
		MaloWIncantersFlowFrameIconOverlay:SetTexture(0, 1, 0, 1.0);
		MaloWIncantersFlowFrameFifthIconOverlay:SetTexture(0, 0, 0, 0.0);
	else
		MaloWIncantersFlowFrameFifthIconOverlay:SetTexture(0, 0, 0, 1.0);
		if increasing then
			MaloWIncantersFlowFrameIconOverlay:SetTexture(1, 1, 0, 1.0);
		else
			MaloWIncantersFlowFrameIconOverlay:SetTexture(1, 0, 0, 1.0);
		end
	end
	
	if stacks >= 4 then
		MaloWIncantersFlowFrameFourthIconOverlay:SetTexture(0, 0, 0, 0.0);
	else
		MaloWIncantersFlowFrameFourthIconOverlay:SetTexture(0, 0, 0, 1.0);
	end
	
	if stacks >= 3 then
		MaloWIncantersFlowFrameThirdIconOverlay:SetTexture(0, 0, 0, 0.0);
	else
		MaloWIncantersFlowFrameThirdIconOverlay:SetTexture(0, 0, 0, 1.0);
	end
	
	if stacks >= 2 then
		MaloWIncantersFlowFrameSecondIconOverlay:SetTexture(0, 0, 0, 0.0);
	else
		MaloWIncantersFlowFrameSecondIconOverlay:SetTexture(0, 0, 0, 1.0);
	end
	
	if stacks >= 1 then
		MaloWIncantersFlowFrameFirstIconOverlay:SetTexture(0, 0, 0, 0.0);
	else
		MaloWIncantersFlowFrameFirstIconOverlay:SetTexture(0, 0, 0, 1.0);
	end
end

function getIncantersFlowStacks()
	for i = 1, 40 do 
		local name,_,_,stacks = UnitBuff("player",i); 
		if name == "Incanter's Flow" then 
			return stacks;
		end 
	end
	return 0;
end
